#include <math.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <fcntl.h>
#include <sys/proxy.h>
#include <sys/kernel.h>
#include <signal.h>
#include <sys/sched.h>
#include <Pt.h>
#include <Ph.h>

#define PX_IMAGE_MODULES
#define PX_GIF_SUPPORT
#define PX_PCX_SUPPORT
#define PX_JPG_SUPPORT
#define PX_BMP_SUPPORT
#include <photon/PxImage.h>

PhDim_t	screen;
PtWidget_t 	*window, *obj;
char		*filepath = "spla320.gif";
PhPoint_t	incpos = {1, 1};

void * image_alloc( long nbytes, int type )
{
	if( type == PX_IMAGE )
		return( PgShmemCreate( nbytes, NULL ) );
	else
		return( calloc( 1,nbytes ) );
}

void image_free( void *memory, int type )
{
	if( type == PX_IMAGE )
		PgShmemDestroy( memory );
	else
		free( memory );
}

void initblit()
{
	PtArg_t	args[10];
	PxMethods_t		methods = {0};
	PhPoint_t		pos = {0, 0};
	PhImage_t		*image;

	methods.flags = PX_LOAD;
	methods.px_alloc = image_alloc;
	methods.px_free = image_free;
	methods.px_progress = NULL;
	
	if ( (image = PxLoadImage( filepath, &methods )) == NULL ) {
		return;
	}
	PtSetArg( &args[0], Pt_ARG_LABEL_DATA, image, sizeof( *image ) );
	PtSetArg( &args[1], Pt_ARG_LABEL_TYPE, Pt_IMAGE, 0 );
	PtSetArg( &args[2], Pt_ARG_POS, &pos, 0 );
	PtSetArg( &args[3], Pt_ARG_FLAGS, Pt_HIGHLIGHTED, Pt_HIGHLIGHTED );
	PtSetArg( &args[4], Pt_ARG_BORDER_WIDTH, 5, 0 );
	PtSetArg( &args[5], Pt_ARG_RESIZE_FLAGS, Pt_RESIZE_XY_ALWAYS, 
                                             Pt_RESIZE_XY_ALWAYS );
	PtSetArg( &args[6], Pt_ARG_FILL_COLOR, Pg_GREY, 0 );
	obj = PtCreateWidget( PtLabel, window, 7, args );
	PtRealizeWidget( obj );
	
}

void drawblit()
{
	PhPoint_t		newpos;
	PhArea_t		*area;
	PtArg_t			args[2];
	
	PtSetArg( &args[0], Pt_ARG_AREA, &area, 0 );
	PtGetResources( obj, 1, args );
	
	newpos.x = area->pos.x + incpos.x;
	newpos.y = area->pos.y + incpos.y;	
	if ((( newpos.x + area->size.w + 10 ) >= screen.w ) || ( newpos.x <= 0 ))
		incpos.x = -incpos.x;
		
	if ((( newpos.y + area->size.h + 10 ) >= screen.h ) || ( newpos.y <= 0 ))
		incpos.y = -incpos.y;
	
	PtSetArg( &args[0], Pt_ARG_POS, &newpos, Pt_BLIT );
	PtSetResources( obj, 1, args );
	

}

#define SAVER_FIELDS Ph_REGION_ORIGIN | Ph_REGION_RECT | Ph_REGION_EV_SENSE |\
					 Ph_REGION_FLAGS | Ph_REGION_HANDLE | Ph_REGION_PARENT |\
					 Ph_REGION_EV_OPAQUE | Ph_REGION_INPUT_GROUP |\
                     Ph_REGION_IN_FRONT

int					password_counter;
char 				real_password[32];

					 
void main (int argc, char *argv[])
{
	PhEvent_t 			*Event;
    pid_t				t_proxy, pid;
	timer_t				id;
	struct itimerspec	timer;
	struct sigevent		t_event;
	float				speed=0;
	long 				sec_rate, nsec_rate;
	double 				garb;
	PhRect_t 			rect;
	PhArea_t 			area;
	PtArg_t	 			arg[15];
	char 				c, *p;
	int					inp_grp = 0;
	PhRid_t				rid;
	PhRegion_t			region;
    PhRawPtrEvent_t 	*ptrdata;    /* raw pointer data */
    PhRawKeyEvent_t 	*keydata;    /* raw keyboard data */
	unsigned			ev_len;

	strcpy( real_password, "root");
	password_counter = 0;

	while ((c = getopt (argc, argv, "S:f:i:")) != 255)
	switch (c)
	{
		case 'S':
			speed = atof(optarg);
			break;
		case 'f':
			filepath = optarg;
			break;
		case 'i':
			incpos.y = incpos.x = atoi( optarg );
			break;
	}
	
	PtInit(NULL);
	PhEventArm();
	setprio(0,4);

	t_proxy = qnx_proxy_attach(0, 0, 0, -1);
	if (t_proxy == -1)
	{
		perror("qnx_proxy_attach:");
		exit(-1);
	}

   	t_event.sigev_signo = -t_proxy;
	id = timer_create(CLOCK_REALTIME, &t_event);
	if (id == -1)
	{
		perror("timer_create:");
		exit(-1);
	}

	sec_rate = (long)floor(speed);
	nsec_rate = modf(speed, &garb) * 1000000000;
			
	timer.it_value.tv_sec = sec_rate;
	timer.it_value.tv_nsec = nsec_rate;
	timer.it_interval.tv_sec = 0;
	timer.it_interval.tv_nsec = 0;
	timer_settime(id, 0, &timer, NULL);

	p = getenv("PHIG");
	if (p)
		inp_grp = atoi(p);
	PhQueryRids( 0, 0, inp_grp, Ph_INPUTGROUP_REGION, 0, 0, 0, &rid, 1 );
	PhRegionQuery( rid, &region, &rect, NULL, 0 );
	inp_grp = region.input_group;
	PhWindowQueryVisible( Ph_QUERY_INPUT_GROUP | Ph_QUERY_EXACT, 0, inp_grp,
                          &rect );
	area.pos.x = rect.ul.x;
	area.pos.y = rect.ul.y;
	screen.w = rect.lr.x - rect.ul.x+1;
	screen.h = rect.lr.y - rect.ul.y+1;		
	area.size = screen;
	PtSetArg(&arg[0], Pt_ARG_AREA, &area, 0);
	PtSetArg(&arg[1], Pt_ARG_REGION_PARENT, 0, 0);
	PtSetArg(&arg[2], Pt_ARG_REGION_HANDLE, 0 ,0);
	PtSetArg(&arg[3], Pt_ARG_REGION_OWNER, 0, 0);
	PtSetArg(&arg[4], Pt_ARG_REGION_FIELDS, SAVER_FIELDS, SAVER_FIELDS);
	PtSetArg(&arg[5], Pt_ARG_REGION_FLAGS, Pt_TRUE, 
                      Ph_FORCE_BOUNDARY|Ph_FORCE_FRONT|Ph_FOLLOW_IG_SIZE );
	PtSetArg(&arg[6], Pt_ARG_REGION_CURSOR, Ph_CURSOR_NONE, 0);
	PtSetArg(&arg[7], Pt_ARG_REGION_CURSOR_COLOR, Pg_BLACK, 0);
	PtSetArg(&arg[8], Pt_ARG_REGION_SENSE, Ph_EV_WIN_SENSE |
 											Ph_EV_KEY |
 											Ph_EV_RAW |
											Ph_EV_PTR_MOTION,
											Ph_EV_WIN_SENSE |
 											Ph_EV_KEY |
 											Ph_EV_RAW |
											Ph_EV_PTR_MOTION );
	PtSetArg(&arg[9], Pt_ARG_REGION_OPAQUE, 
             Ph_EV_DRAW|Ph_EV_KEY|Ph_EV_PTR_ALL|Ph_EV_EXPOSE|Ph_EV_BOUNDARY,
	         Ph_EV_DRAW|Ph_EV_KEY|Ph_EV_PTR_ALL|Ph_EV_EXPOSE|Ph_EV_BOUNDARY ); 
	PtSetArg(&arg[10], Pt_ARG_FILL_COLOR, Pg_BLACK, 0 );
	PtSetArg(&arg[11], Pt_ARG_COLOR, Pg_WHITE, 0 );
	PtSetArg(&arg[12], Pt_ARG_REGION_INFRONT, Ph_DEV_RID, 0 );
	PtSetArg(&arg[13], Pt_ARG_REGION_INPUT_GROUP, inp_grp, 0 );
	window = PtCreateWidget( PtRegion, NULL, 14, arg );

	initblit();	

	PtRealizeWidget(window);
	
	
	if( NULL == 
		( Event = malloc( sizeof(  PhEvent_t ) + 1000 ) ) ) {
		fprintf( stderr, "memory problems\n" );
		exit( -1 );
	}

	while (1)
	{
		if ( nsec_rate || sec_rate )
			pid = Receive( 0, 0, 0 );
		else
			pid = Creceive(0, 0, 0);
		if ( pid ) {
			switch( PhEventRead(pid, Event, sizeof( PhEvent_t ) + 1000 ) ) 
			{
				case Ph_EVENT_MSG:
					ev_len = sizeof( PhEvent_t ) +
								sizeof( PhRect_t ) * Event->num_rects +
								Event->data_len;

            		print_event_type(Event->type);
            		print_event_subtype(Event->subtype);

            		fprintf(stdout,"num_rects=%u, data_len=%u ev_len=%d",
                    		Event->num_rects, Event->data_len, ev_len );

            		switch ( Event->type ) {
                		case Ph_EV_DRAW:
								break;
                		case Ph_EV_KEY:
                                keydata = PhGetData( Event );
                                fprintf(stdout,
                                "key: cap=%lu, sym=%lu flags=%lu mod=%lu ", 
                                        keydata->key_cap,
                                        keydata->key_sym,
                                        keydata->key_flags,
                                        keydata->key_mods
                                        );
								if ( keydata->key_flags & Pk_KF_Key_Down )
								   if ( check_password( keydata->key_cap ) ) 
									   exit(0);
								break;
                		case Ph_EV_BUT_PRESS:
								printf("but press\n");
								break;
                		case Ph_EV_BUT_RELEASE:
								printf("but release\n");
								break;
                		case Ph_EV_PTR_MOTION_NOBUTTON:
								printf("ptr motion nobutton\n");
								break;
                		case Ph_EV_PTR_MOTION_BUTTON:
								printf("ptr motion button\n");
								break;
                		case Ph_EV_RAW:
                               /* raw pointer event */
                               switch ( Event->subtype ) {
                                    case Ph_EV_RAW_KEY:
                                          fprintf(stdout,"Key: ");
                                          keydata = PhGetData( Event );
                                          fprintf(stdout,
                                "rawkey: cap=%lu, sym=%lu flags=%lu mod=%lu ", 
                                                  keydata->key_cap,
                                                  keydata->key_sym,
                                                  keydata->key_flags,
                                                  keydata->key_mods
                                                  );
                                          break;
                                    case Ph_EV_RAW_PTR:
                                          fprintf(stdout,"Ptr: ");
                                          ptrdata = PhGetData( Event );
                                          fprintf(stdout,
                                    "button_state=%u flags=%x, raw_flags=%x ",
                                                  ptrdata->button_state, 
                                                  ptrdata->flags, 
                                                  ptrdata->raw_flags);
                                          break;
                                    default:
                                          break;
                                    }
                                 break;
                		case Ph_EV_SYSTEM:
                                 break;
                		case Ph_EV_BOUNDARY:
                                 break;
                		case Ph_EV_EXPOSE:
                                 break;
                		default:
                                 printf("type=%lx\n", Event->type );
                                 break;
                        }
					// PtEventHandler( Event );
					break;
				case 0:
					if ( sec_rate || nsec_rate )
						timer_settime(id, 0, &timer, NULL);
					drawblit();
					break;
			}				
		} else {
			drawblit();
			PgFlush();
		}
	}
}

int check_password( long key )
{
static int try = 0;

try++;

if ( try > strlen( real_password ) || key == '`' ) {
	password_counter = 0;
	try = 0;
	}

printf("pcounter=%d, key=%c\n", password_counter, key );
if ( key == real_password[password_counter] )
	password_counter++;
if ( password_counter >= strlen( real_password ) )
	return(1);
else
	return(0);
}


print_event_type( long event )
{
if ( event & Ph_EV_RAW )
   printf("RAW ");

if ( event & Ph_EV_BUT_PRESS )
   printf("BUT_PRESS ");

if ( event & Ph_EV_BUT_RELEASE )
   printf("BUT_RELEASE ");

if ( event & Ph_EV_PTR_MOTION_NOBUTTON )
   printf("PTR_MOTION_NOBUTTON ");

if ( event & Ph_EV_PTR_MOTION_BUTTON )
   printf("PTR_MOTION_BUTTON ");

if ( event & Ph_EV_BOUNDARY )
   printf("BOUNDARY ");

if ( event & Ph_EV_EXPOSE )
   printf("EXPOSE ");

if ( event & Ph_EV_DRAW )
   printf("DRAW ");

if ( event & Ph_EV_AMIN )
   printf("AMIN ");

if ( event & Ph_EV_DRAG )
   printf("DRAG ");

if ( event & Ph_EV_COVERED )
   printf("COVERED ");

if ( event & Ph_EV_BLIT )
   printf("BLIT ");

if ( event & Ph_EV_SYSTEM )
   printf("SYSTEM ");

if ( event & Ph_EV_WM )
   printf("WM ");

if ( event & Ph_EV_BUT_REPEAT )
   printf("BUT_REPEAT ");

if ( event & Ph_EV_RAW )
   printf("RAW ");
}

print_event_subtype( unsigned short event )
{
printf("Subtype %u ", event);
}

